--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["4"] = 1,["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 1,["16"] = 1,["17"] = 1,["18"] = 1,["19"] = 1,["20"] = 1,["21"] = 1,["22"] = 1,["23"] = 1,["24"] = 1,["25"] = 8,["26"] = 8,["27"] = 8,["28"] = 8,["29"] = 1,["30"] = 1,["31"] = 1,["32"] = 1,["33"] = 1,["34"] = 1,["35"] = 1,["36"] = 1,["37"] = 16,["38"] = 21,["39"] = 23,["40"] = 21,["41"] = 21,["42"] = 21,["43"] = 21,["44"] = 31,["45"] = 21,["46"] = 21,["47"] = 21,["48"] = 21,["49"] = 21,["50"] = 21,["51"] = 21,["52"] = 1,["53"] = 40,["54"] = 43,["55"] = 42,["57"] = 42,["58"] = 42,["59"] = 1,["60"] = 52,["61"] = 55,["62"] = 54,["64"] = 54,["65"] = 54,["66"] = 1,["67"] = 62,["68"] = 62,["69"] = 62,["70"] = 62,["71"] = 62,["72"] = 1,["73"] = 69,["74"] = 69,["75"] = 69,["76"] = 69,["77"] = 69,["78"] = 1,["79"] = 76,["80"] = 76,["81"] = 76,["82"] = 76,["83"] = 76,["84"] = 1,["85"] = 83,["86"] = 83,["87"] = 1,["88"] = 87,["89"] = 87,["90"] = 1,["91"] = 91,["92"] = 91,["93"] = 1,["94"] = 95,["95"] = 95,["96"] = 95,["97"] = 1,["98"] = 100,["99"] = 100,["100"] = 100,["101"] = 1,["102"] = 105,["103"] = 105,["104"] = 105,["105"] = 1,["106"] = 1});
local ____exports = {}
local __TSTL_tstl_gc_optimized_collections = require("tstl-gc-optimized-collections")
local GCOptimizedList = __TSTL_tstl_gc_optimized_collections.GCOptimizedList
local GCOptimizedMap = __TSTL_tstl_gc_optimized_collections.GCOptimizedMap
local __TSTL_component = require("encompass-ecs.component")
local Component = __TSTL_component.Component
local __TSTL_draw_layer_manager = require("encompass-ecs.draw_layer_manager")
local DrawLayerManager = __TSTL_draw_layer_manager.DrawLayerManager
local __TSTL_component_user_data_only = require("encompass-ecs.interfaces.component_user_data_only")
local ComponentUserDataOnly = __TSTL_component_user_data_only.ComponentUserDataOnly
local __TSTL_drawable = require("encompass-ecs.interfaces.drawable")
local IDrawable = __TSTL_drawable.IDrawable
local __TSTL_generic_type = require("encompass-ecs.types.generic_type")
local Type = __TSTL_generic_type.Type
____exports.ComponentManager = {}
local ComponentManager = ____exports.ComponentManager
ComponentManager.name = "ComponentManager"
ComponentManager.__index = ComponentManager
ComponentManager.prototype = {}
ComponentManager.prototype.__index = ComponentManager.prototype
ComponentManager.prototype.constructor = ComponentManager
function ComponentManager.new(...)
    local self = setmetatable({}, ComponentManager.prototype)
    self:____constructor(...)
    return self
end
function ComponentManager.prototype.____constructor(self)
    self.component_type_to_active_components_map = GCOptimizedMap.new()
    self.component_type_to_inactive_components_map = GCOptimizedMap.new()
    self.components_to_activate = GCOptimizedList.new()
    self.components_to_deactivate = GCOptimizedList.new()
    self.components_to_remove = GCOptimizedList.new()
end
function ComponentManager.prototype.create_component(self, ComponentType, entity_id, draw_layer_manager, properties)
    local component = ComponentType.new(ComponentType, entity_id, draw_layer_manager)
    if not self.component_type_to_active_components_map:has(ComponentType) then
        self.component_type_to_active_components_map:set(ComponentType, GCOptimizedList.new())
        self.component_type_to_inactive_components_map:set(ComponentType, GCOptimizedList.new())
    end
    self:mark_for_activation(component)
    if properties ~= nil then
        local ____TS_array = __TS__ObjectEntries(properties)
        for ____TS_index = 1, #____TS_array do
            local key, value = unpack(____TS_array[____TS_index])
            component[key] = value
        end
    end
    return component
end
function ComponentManager.prototype.get_components_by_component_type(self, ComponentType)
    if self.component_type_to_active_components_map:has(ComponentType) then
        return self.component_type_to_active_components_map:get(ComponentType)
    else
        return GCOptimizedList.Empty
    end
end
function ComponentManager.prototype.get_inactive_components_by_component_type(self, ComponentType)
    if self.component_type_to_inactive_components_map:has(ComponentType) then
        return self.component_type_to_inactive_components_map:get(ComponentType)
    else
        return GCOptimizedList.Empty
    end
end
function ComponentManager.prototype.activate_components(self)
    for component in self.components_to_activate:values() do
        self:perform_activate_component(component)
    end
    self.components_to_activate:clear()
end
function ComponentManager.prototype.deactivate_components(self)
    for component in self.components_to_deactivate:values() do
        self:perform_deactivate_component(component)
    end
    self.components_to_deactivate:clear()
end
function ComponentManager.prototype.remove_components(self)
    for component in self.components_to_remove:values() do
        self:perform_remove_component(component)
    end
    self.components_to_remove:clear()
end
function ComponentManager.prototype.mark_for_activation(self, component)
    self.components_to_activate:add(component)
end
function ComponentManager.prototype.mark_for_deactivation(self, component)
    self.components_to_deactivate:add(component)
end
function ComponentManager.prototype.mark_for_removal(self, component)
    self.components_to_remove:add(component)
end
function ComponentManager.prototype.perform_remove_component(self, component)
    self.component_type_to_active_components_map:get(component.type):deleteValue(component)
    self.component_type_to_inactive_components_map:get(component.type):deleteValue(component)
end
function ComponentManager.prototype.perform_deactivate_component(self, component)
    self.component_type_to_active_components_map:get(component.type):deleteValue(component)
    self.component_type_to_inactive_components_map:get(component.type):add(component)
end
function ComponentManager.prototype.perform_activate_component(self, component)
    self.component_type_to_inactive_components_map:get(component.type):deleteValue(component)
    self.component_type_to_active_components_map:get(component.type):add(component)
end
return ____exports
