--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["4"] = 1,["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 1,["16"] = 1,["17"] = 1,["18"] = 1,["19"] = 1,["20"] = 1,["21"] = 1,["22"] = 1,["23"] = 1,["24"] = 1,["25"] = 1,["26"] = 1,["27"] = 1,["28"] = 1,["29"] = 1,["30"] = 1,["31"] = 1,["32"] = 1,["33"] = 1,["34"] = 1,["35"] = 1,["36"] = 1,["37"] = 1,["38"] = 1,["39"] = 1,["40"] = 1,["41"] = 1,["42"] = 29,["43"] = 29,["44"] = 29,["45"] = 29,["46"] = 1,["47"] = 39,["48"] = 30,["49"] = 31,["50"] = 32,["51"] = 39,["52"] = 39,["53"] = 39,["54"] = 39,["55"] = 1,["56"] = 56,["57"] = 56,["58"] = 1,["59"] = 67,["60"] = 70,["61"] = 69,["63"] = 69,["64"] = 69,["65"] = 69,["66"] = 1,["67"] = 85,["68"] = 88,["69"] = 88,["70"] = 88,["71"] = 1,["72"] = 101,["73"] = 104,["74"] = 104,["75"] = 104,["76"] = 1,["77"] = 115,["78"] = 115,["79"] = 1,["80"] = 126,["81"] = 128,["82"] = 1,["83"] = 139,["84"] = 141,["85"] = 143,["86"] = 141,["87"] = 145,["88"] = 141,["90"] = 141,["91"] = 141,["92"] = 141,["93"] = 1,["94"] = 162,["95"] = 165,["96"] = 164,["98"] = 164,["99"] = 164,["100"] = 164,["101"] = 1,["102"] = 182,["103"] = 185,["104"] = 184,["105"] = 187,["106"] = 184,["107"] = 189,["108"] = 184,["110"] = 184,["111"] = 184,["112"] = 184,["114"] = 184,["115"] = 184,["116"] = 184,["117"] = 1,["118"] = 207,["119"] = 208,["120"] = 207,["122"] = 207,["123"] = 207,["124"] = 207,["125"] = 1,["126"] = 222,["127"] = 224,["128"] = 1,["129"] = 234,["130"] = 237,["131"] = 236,["133"] = 236,["134"] = 236,["135"] = 236,["136"] = 1,["137"] = 251,["138"] = 254,["139"] = 253,["141"] = 253,["142"] = 253,["143"] = 253,["144"] = 1,["145"] = 1});
local ____exports = {}
local __TSTL_tstl_gc_optimized_collections = require("tstl-gc-optimized-collections")
local GCOptimizedList = __TSTL_tstl_gc_optimized_collections.GCOptimizedList
local __TSTL_component = require("encompass-ecs.component")
local Component = __TSTL_component.Component
local __TSTL_component_manager = require("encompass-ecs.component_manager")
local ComponentManager = __TSTL_component_manager.ComponentManager
local __TSTL_entity = require("encompass-ecs.entity")
local Entity = __TSTL_entity.Entity
local __TSTL_entity_creator = require("encompass-ecs.entity_creator")
local EntityCreator = __TSTL_entity_creator.EntityCreator
local __TSTL_entity_manager = require("encompass-ecs.entity_manager")
local EntityManager = __TSTL_entity_manager.EntityManager
local __TSTL_emit_undeclared_message = require("encompass-ecs.errors.emit_undeclared_message")
local EmitUndeclaredMessageError = __TSTL_emit_undeclared_message.EmitUndeclaredMessageError
local __TSTL_illegal_component_mutation = require("encompass-ecs.errors.illegal_component_mutation")
local IllegalComponentMutationError = __TSTL_illegal_component_mutation.IllegalComponentMutationError
local __TSTL_read_undeclared_message = require("encompass-ecs.errors.read_undeclared_message")
local ReadUndeclaredMessage = __TSTL_read_undeclared_message.ReadUndeclaredMessage
local __TSTL_singleton_read = require("encompass-ecs.errors.singleton_read")
local SingletonReadError = __TSTL_singleton_read.SingletonReadError
local __TSTL_message = require("encompass-ecs.message")
local Message = __TSTL_message.Message
local __TSTL_message_manager = require("encompass-ecs.message_manager")
local MessageManager = __TSTL_message_manager.MessageManager
local __TSTL_component_message = require("encompass-ecs.types.component_message")
local ComponentMessage = __TSTL_component_message.ComponentMessage
local __TSTL_entity_message = require("encompass-ecs.types.entity_message")
local EntityMessage = __TSTL_entity_message.EntityMessage
local __TSTL_generic_type = require("encompass-ecs.types.generic_type")
local Type = __TSTL_generic_type.Type
____exports.Engine = {}
local Engine = ____exports.Engine
Engine.name = "Engine"
Engine.__index = Engine
Engine.prototype = {}
Engine.prototype.__index = Engine.prototype
Engine.prototype.constructor = Engine
function Engine.new(...)
    local self = setmetatable({}, Engine.prototype)
    self:____constructor(...)
    return self
end
function Engine.prototype.____constructor(self, entity_manager, entity_creator, component_manager, message_manager)
    self.emit_message_types = GCOptimizedList.new()
    self.read_message_types = GCOptimizedList.new()
    self.mutate_component_types = GCOptimizedList.new()
    self.entity_manager = entity_manager
    self.entity_creator = entity_creator
    self.component_manager = component_manager
    self.message_manager = message_manager
end
function Engine.prototype.create_entity(self)
    return self.entity_creator:create_entity()
end
function Engine.prototype.emit_message(self, MessageType)
    if self.emit_message_types:hasValue(MessageType) then
        return self.message_manager:create_message(MessageType)
    else
        local message_error = EmitUndeclaredMessageError.new(self.constructor.name, MessageType)
        error(tostring(message_error))
    end
end
function Engine.prototype.emit_component_message(self, MessageType, component)
    local message = self:emit_message(MessageType)
    message.component = component
    return message
end
function Engine.prototype.emit_entity_message(self, MessageType, entity)
    local message = self:emit_message(MessageType)
    message.entity = entity
    return message
end
function Engine.prototype.get_entity(self, entity_id)
    return self.entity_manager:get_entity(entity_id)
end
function Engine.prototype.read_components(self, ComponentType)
    return self.component_manager:get_components_by_component_type(ComponentType)
end
function Engine.prototype.read_component(self, ComponentType)
    local components = self.component_manager:get_components_by_component_type(ComponentType)
    if components.size == 0 then
        return nil
    elseif components.size == 1 then
        return components:get(0)
    else
        local multiple_component_error = SingletonReadError.new(self.constructor.name, ComponentType)
        error(tostring(multiple_component_error))
    end
end
function Engine.prototype.read_components_mutable(self, ComponentType)
    if self.mutate_component_types:hasValue(ComponentType) then
        return self.component_manager:get_components_by_component_type(ComponentType)
    else
        local mutate_error = IllegalComponentMutationError.new(self.constructor.name, ComponentType)
        error(tostring(mutate_error))
    end
end
function Engine.prototype.read_component_mutable(self, ComponentType)
    if self.mutate_component_types:hasValue(ComponentType) then
        local components = self.component_manager:get_components_by_component_type(ComponentType)
        if components.size == 0 then
            return nil
        elseif components.size == 1 then
            return components:get(0)
        else
            local multiple_component_error = SingletonReadError.new(self.constructor.name, ComponentType)
            error(tostring(multiple_component_error))
        end
    else
        local mutate_error = IllegalComponentMutationError.new(self.constructor.name, ComponentType)
        error(tostring(mutate_error))
    end
end
function Engine.prototype.make_mutable(self, component)
    if self.mutate_component_types:hasValue(component.type) then
        return component
    else
        local mutate_error = IllegalComponentMutationError.new(self.constructor.name, component.type)
        error(tostring(mutate_error))
    end
end
function Engine.prototype.read_inactive_components(self, ComponentType)
    return self.component_manager:get_inactive_components_by_component_type(ComponentType)
end
function Engine.prototype.read_messages(self, MessageType)
    if self.read_message_types:hasValue(MessageType) then
        return self.message_manager:get_messages_by_message_type(MessageType)
    else
        local message_error = ReadUndeclaredMessage.new(self.constructor.name, MessageType)
        error(tostring(message_error))
    end
end
function Engine.prototype.some(self, MessageType)
    if self.read_message_types:hasValue(MessageType) then
        return self.message_manager:get_messages_by_message_type(MessageType).size > 0
    else
        local message_error = ReadUndeclaredMessage.new(self.constructor.name, MessageType)
        error(tostring(message_error))
    end
end
return ____exports
