--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["4"] = 1,["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 1,["16"] = 1,["17"] = 1,["18"] = 1,["19"] = 1,["20"] = 1,["21"] = 1,["22"] = 1,["23"] = 1,["24"] = 1,["25"] = 1,["26"] = 1,["27"] = 1,["28"] = 1,["29"] = 1,["30"] = 1,["31"] = 1,["32"] = 11,["33"] = 11,["34"] = 11,["35"] = 11,["36"] = 1,["37"] = 1,["38"] = 1,["39"] = 1,["40"] = 1,["41"] = 1,["42"] = 1,["43"] = 19,["44"] = 22,["45"] = 22,["46"] = 22,["47"] = 22,["48"] = 22,["49"] = 1,["50"] = 31,["51"] = 34,["52"] = 34,["53"] = 34,["54"] = 34,["55"] = 34,["56"] = 1,["57"] = 42,["58"] = 44,["59"] = 44,["60"] = 44,["61"] = 44,["62"] = 1,["63"] = 51,["64"] = 51,["65"] = 51,["66"] = 51,["67"] = 51,["68"] = 51,["69"] = 51,["70"] = 51,["71"] = 1,["72"] = 63,["73"] = 64,["74"] = 63,["76"] = 63,["77"] = 63,["78"] = 1,["79"] = 71,["80"] = 72,["81"] = 71,["82"] = 71,["83"] = 71,["84"] = 1,["85"] = 78,["86"] = 79,["87"] = 78,["88"] = 78,["89"] = 78,["90"] = 1,["91"] = 1});
local ____exports = {}
local __TSTL_tstl_gc_optimized_collections = require("tstl-gc-optimized-collections")
local GCOptimizedList = __TSTL_tstl_gc_optimized_collections.GCOptimizedList
local GCOptimizedMap = __TSTL_tstl_gc_optimized_collections.GCOptimizedMap
local GCOptimizedSet = __TSTL_tstl_gc_optimized_collections.GCOptimizedSet
local __TSTL_component = require("encompass-ecs.component")
local Component = __TSTL_component.Component
local __TSTL_entity = require("encompass-ecs.entity")
local Entity = __TSTL_entity.Entity
local __TSTL_message = require("encompass-ecs.message")
local Message = __TSTL_message.Message
local __TSTL_message_pool = require("encompass-ecs.message_pool")
local MessagePool = __TSTL_message_pool.MessagePool
local __TSTL_message_query = require("encompass-ecs.message_query")
local MessageQuery = __TSTL_message_query.MessageQuery
local __TSTL_component_message = require("encompass-ecs.types.component_message")
local ComponentMessage = __TSTL_component_message.ComponentMessage
local __TSTL_entity_message = require("encompass-ecs.types.entity_message")
local EntityMessage = __TSTL_entity_message.EntityMessage
local __TSTL_generic_type = require("encompass-ecs.types.generic_type")
local Type = __TSTL_generic_type.Type
____exports.MessageManager = {}
local MessageManager = ____exports.MessageManager
MessageManager.name = "MessageManager"
MessageManager.__index = MessageManager
MessageManager.prototype = {}
MessageManager.prototype.__index = MessageManager.prototype
MessageManager.prototype.constructor = MessageManager
function MessageManager.new(...)
    local self = setmetatable({}, MessageManager.prototype)
    self:____constructor(...)
    return self
end
function MessageManager.prototype.____constructor(self)
    self.message_query = MessageQuery.new()
    self.messages = GCOptimizedSet.new()
    self.message_pools = GCOptimizedMap.new()
    self.message_type_to_messages_map = GCOptimizedMap.new()
end
function MessageManager.prototype.create_component_message(self, ComponentMessageType, component)
    local component_message = self:create_or_get_message_pool(ComponentMessageType):obtain()
    component_message.component = component
    self.messages:add(component_message)
    self:cache_message_by_message_type(component_message)
    return component_message
end
function MessageManager.prototype.create_entity_message(self, EntityMessageType, entity)
    local entity_message = self:create_or_get_message_pool(EntityMessageType):obtain()
    entity_message.entity = entity
    self.messages:add(entity_message)
    self:cache_message_by_message_type(entity_message)
    return entity_message
end
function MessageManager.prototype.create_message(self, MessageType)
    local message = self:create_or_get_message_pool(MessageType):obtain()
    self.messages:add(message)
    self:cache_message_by_message_type(message)
    return message
end
function MessageManager.prototype.clear_messages(self)
    for _, message_set in self.message_type_to_messages_map:entries() do
        message_set:clear()
    end
    for message in self.messages:entries() do
        self.message_pools:get(message.type):free(message)
    end
    self.messages:clear()
end
function MessageManager.prototype.get_messages_by_message_type(self, MessageType)
    if self.message_type_to_messages_map:has(MessageType) then
        return self.message_type_to_messages_map:get(MessageType)
    else
        return GCOptimizedList.Empty
    end
end
function MessageManager.prototype.cache_message_by_message_type(self, message)
    if not self.message_type_to_messages_map:get(message.type) then
        self.message_type_to_messages_map:set(message.type, GCOptimizedList.new())
    end
    self.message_type_to_messages_map:get(message.type):add(message)
end
function MessageManager.prototype.create_or_get_message_pool(self, MessageType)
    if not self.message_pools:has(MessageType) then
        self.message_pools:set(MessageType, MessagePool.new(MessageType))
    end
    return self.message_pools:get(MessageType)
end
return ____exports
