--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["4"] = 1,["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 1,["16"] = 1,["17"] = 4,["18"] = 4,["19"] = 4,["20"] = 4,["21"] = 1,["22"] = 38,["23"] = 40,["24"] = 40,["25"] = 38,["26"] = 41,["27"] = 41,["28"] = 38,["29"] = 42,["30"] = 42,["31"] = 38,["32"] = 38,["33"] = 38,["34"] = 38,["35"] = 38,["36"] = 38,["37"] = 38,["38"] = 38,["39"] = 38,["40"] = 1,["41"] = 1,["42"] = 1,["43"] = 1,["44"] = 1,["45"] = 1,["46"] = 1,["47"] = 1,["48"] = 1,["49"] = 1,["50"] = 56,["51"] = 56,["52"] = 58,["53"] = 59,["54"] = 60,["55"] = 59,["56"] = 59,["57"] = 56,["58"] = 56,["59"] = 56,["60"] = 56,["61"] = 1,["62"] = 69,["63"] = 70,["64"] = 69,["65"] = 69,["67"] = 69,["68"] = 69,["69"] = 1,["70"] = 78,["71"] = 78,["72"] = 78,["73"] = 78,["74"] = 1,["75"] = 84,["76"] = 84,["77"] = 86,["78"] = 86,["79"] = 86,["80"] = 86,["81"] = 84,["82"] = 1,["83"] = 93,["84"] = 94,["85"] = 93,["87"] = 93,["88"] = 93,["89"] = 1,["90"] = 1,["91"] = 1,["92"] = 11,["93"] = 1,["94"] = 1,["95"] = 15,["96"] = 15,["97"] = 15,["98"] = 1,["99"] = 1,["100"] = 23,["101"] = 24,["102"] = 23,["103"] = 23,["104"] = 21,["105"] = 1,["106"] = 1});
local ____exports = {}
local __TSTL_tstl_gc_optimized_collections = require("tstl-gc-optimized-collections")
local GCOptimizedList = __TSTL_tstl_gc_optimized_collections.GCOptimizedList
local __TSTL_generic_type = require("encompass-ecs.types.generic_type")
local Type = __TSTL_generic_type.Type
____exports.ObjectPool = {}
local ObjectPool = ____exports.ObjectPool
ObjectPool.name = "ObjectPool"
ObjectPool.__index = ObjectPool
ObjectPool.prototype = {}
ObjectPool.prototype.____getters = {}
ObjectPool.prototype.__index = __TS__Index(ObjectPool.prototype)
ObjectPool.prototype.constructor = ObjectPool
function ObjectPool.new(...)
    local self = setmetatable({}, ObjectPool.prototype)
    self:____constructor(...)
    return self
end
function ObjectPool.prototype.____constructor(self, object_constructor, object_destructor, size, overflow_behavior)
    if object_destructor == nil then
        object_destructor = ____exports.ObjectPool.DefaultDestructor
    end
    if size == nil then
        size = 16
    end
    if overflow_behavior == nil then
        overflow_behavior = ____exports.ObjectPool.OverflowBehaviorExpand
    end
    self._size = size
    self._inactive_objects = GCOptimizedList.new()
    self._active_objects = GCOptimizedList.new()
    self.reference_object = object_constructor.new(object_constructor)
    self.constructor_function = object_constructor
    self.destructor_function = object_destructor
    self.overflow_behavior = overflow_behavior
    self:generate(size)
end
function ObjectPool.prototype.____getters.size(self)
    return self._size
end
function ObjectPool.prototype.____getters.inactive_objects(self)
    return self._inactive_objects
end
function ObjectPool.prototype.____getters.active_objects(self)
    return self._active_objects
end
function ObjectPool.prototype.obtain(self)
    local object = self:get_inactive_object()
    if object ~= nil then
        for key in pairs(object) do
            if key ~= "_type" and key ~= "type" then
                object[key] = self.reference_object[key]
            end
        end
        self._active_objects:add(object)
    end
    return object
end
function ObjectPool.prototype.free(self, instance)
    if self.active_objects:deleteValue(instance) then
        self.inactive_objects:add(instance)
        self:destructor_function(instance)
    else
        error(("cannot free object which is not from pool"))
    end
end
function ObjectPool.prototype.free_all(self)
    for _, object in self.active_objects:entries() do
        self:free(object)
    end
end
function ObjectPool.prototype.generate(self, amount)
    local i = 0
    while i < amount do
        local object = self.constructor_function.new(self.constructor_function)
        self._inactive_objects:add(object)
        i = i + 1
    end
end
function ObjectPool.prototype.get_inactive_object(self)
    if self._inactive_objects.size > 0 then
        return self._inactive_objects:pop()
    else
        return self:overflow_behavior(self)
    end
end
ObjectPool.OverflowBehaviorFallible = function() return nil end
ObjectPool.OverflowBehaviorCycle = function(____, pool)
    return pool.active_objects:shift()
end
ObjectPool.OverflowBehaviorExpand = function(____, pool)
    pool:generate(pool.size)
    pool._size = pool._size * 2
    return pool._inactive_objects:pop()
end
ObjectPool.DefaultDestructor = function(____, object)
    for key in pairs(object) do
        if key ~= "_type" and key ~= "type" then
            object[key] = nil
        end
    end
end
return ____exports
