/** @luaIterator @tupleReturn */
export interface IGCOptimizedMapIterable<T> extends Iterable<T> {
}
export declare class GCOptimizedMap<TKey, TValue> {
    static readonly Empty: GCOptimizedMap<any, any>;
    readonly size: number;
    private items;
    constructor(...entries: [TKey, TValue][]);
    entries(): IGCOptimizedMapIterable<[TKey, TValue]>;
    clear(): void;
    delete(key: TKey): boolean;
    get(key: TKey): TValue | undefined;
    has(key: TKey): boolean;
    set(key: TKey, value: TValue): GCOptimizedMap<TKey, TValue>;
}
