// this has a hack to get around TSTL clobbering class names
// once TSTL supports better class name logic, rewrite please

import { GCOptimizedList } from "tstl-gc-optimized-collections";
import { Message } from "../../message";
import { Type } from "../../types/generic_type";

declare const _VERSION: string | undefined;

export function Reads(...message_type_args: Type<Message>[]) {
    return <T extends new(...args: any[]) => {}>(constructor: T) => {
        const c = class extends constructor {
            protected read_message_types = new GCOptimizedList<Type<Message>>(...message_type_args);
        };
        if (typeof _VERSION !== "undefined") {
            (c as any).name = constructor.name; // hack until TSTL has more clever class name logic
        }
        return c;
    };
}
