import { Message } from "../message";
import { Type } from "../types/generic_type";

export class ReadUndeclaredMessage {
    private message_type: Type<Message>;
    private engine_name: string;

    constructor(engine_name: string, message_type: Type<Message>) {
        this.engine_name = engine_name;
        this.message_type = message_type;
    }

    public toString() {
        return this.engine_name + " tried to read an undeclared message: " + this.message_type.name;
    }
}
