--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["4"] = 1,["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 1,["16"] = 1,["17"] = 1,["18"] = 1,["19"] = 1,["20"] = 1,["21"] = 1,["22"] = 1,["23"] = 1,["24"] = 1,["25"] = 1,["26"] = 8,["27"] = 8,["28"] = 8,["29"] = 8,["30"] = 1,["31"] = 19,["32"] = 16,["33"] = 17,["34"] = 19,["35"] = 19,["36"] = 19,["37"] = 19,["38"] = 19,["39"] = 1,["40"] = 33,["41"] = 33,["42"] = 33,["43"] = 33,["44"] = 33,["45"] = 1,["46"] = 40,["47"] = 40,["48"] = 42,["49"] = 40,["50"] = 44,["51"] = 40,["52"] = 40,["53"] = 40,["54"] = 40,["55"] = 40,["56"] = 40,["57"] = 1,["58"] = 53,["59"] = 53,["60"] = 53,["61"] = 53,["62"] = 53,["63"] = 53,["64"] = 53,["65"] = 1,["66"] = 60,["67"] = 60,["68"] = 60,["69"] = 60,["70"] = 1,["71"] = 66,["72"] = 66,["73"] = 66,["74"] = 70,["75"] = 66,["76"] = 66,["77"] = 66,["78"] = 66,["79"] = 66,["80"] = 66,["81"] = 66,["82"] = 66,["83"] = 66,["84"] = 1,["85"] = 85,["86"] = 85,["87"] = 1,["88"] = 89,["89"] = 89,["90"] = 1,["91"] = 94,["92"] = 95,["93"] = 94,["94"] = 94,["95"] = 94,["96"] = 1,["97"] = 101,["98"] = 101,["99"] = 103,["100"] = 101,["101"] = 105,["102"] = 106,["103"] = 101,["104"] = 101,["105"] = 101,["106"] = 101,["107"] = 101,["108"] = 101,["109"] = 101,["110"] = 1,["111"] = 1});
local ____exports = {}
local __TSTL_tstl_gc_optimized_collections = require("tstl-gc-optimized-collections")
local GCOptimizedList = __TSTL_tstl_gc_optimized_collections.GCOptimizedList
local GCOptimizedMap = __TSTL_tstl_gc_optimized_collections.GCOptimizedMap
local GCOptimizedSet = __TSTL_tstl_gc_optimized_collections.GCOptimizedSet
local __TSTL_component = require("encompass-ecs.component")
local Component = __TSTL_component.Component
local __TSTL_entity = require("encompass-ecs.entity")
local Entity = __TSTL_entity.Entity
local __TSTL_drawable_entity_tracker = require("encompass-ecs.interfaces.drawable_entity_tracker")
local IDrawableEntityTracker = __TSTL_drawable_entity_tracker.IDrawableEntityTracker
local __TSTL_entity_tracker = require("encompass-ecs.interfaces.entity_tracker")
local IEntityTracker = __TSTL_entity_tracker.IEntityTracker
local __TSTL_generic_type = require("encompass-ecs.types.generic_type")
local Type = __TSTL_generic_type.Type
____exports.EntityManager = {}
local EntityManager = ____exports.EntityManager
EntityManager.name = "EntityManager"
EntityManager.__index = EntityManager
EntityManager.prototype = {}
EntityManager.prototype.__index = EntityManager.prototype
EntityManager.prototype.constructor = EntityManager
function EntityManager.new(...)
    local self = setmetatable({}, EntityManager.prototype)
    self:____constructor(...)
    return self
end
function EntityManager.prototype.____constructor(self, entities, id_to_entity, entities_with_added_components, entities_with_removed_components, entities_marked_for_destroy)
    self.entity_to_entity_trackers_map = GCOptimizedMap.new()
    self.component_type_to_entity_trackers_map = GCOptimizedMap.new()
    self.entities = entities
    self.id_to_entity = id_to_entity
    self.entities_with_added_components = entities_with_added_components
    self.entities_with_removed_components = entities_with_removed_components
    self.entities_marked_for_destroy = entities_marked_for_destroy
end
function EntityManager.prototype.check_entities_with_added_components(self)
    for entity in self.entities_with_added_components:values() do
        self:check_and_register_entity(entity)
    end
    self.entities_with_added_components:clear()
end
function EntityManager.prototype.check_entities_with_removed_components(self)
    for entity in self.entities_with_removed_components:values() do
        if self.entity_to_entity_trackers_map:has(entity) then
            for engine in self.entity_to_entity_trackers_map:get(entity):entries() do
                if self:is_entity_tracker(engine) then
                    engine:check_and_untrack_entity(entity.id)
                end
            end
        end
    end
    self.entities_with_removed_components:clear()
end
function EntityManager.prototype.register_entity_tracker(self, entity_tracker)
    local ____TS_array = entity_tracker.component_types
    for ____TS_index = 1, #____TS_array do
        local component_type = ____TS_array[____TS_index]
        local entity_tracker_set = self:get_or_create_entity_tracker_set(component_type)
        entity_tracker_set:add(entity_tracker)
    end
end
function EntityManager.prototype.register_drawable_entity_tracker(self, drawable_entity_tracker)
    self:register_entity_tracker(drawable_entity_tracker)
    local entity_tracker_set = self:get_or_create_entity_tracker_set(drawable_entity_tracker.draw_component_type)
    entity_tracker_set:add(drawable_entity_tracker)
end
function EntityManager.prototype.destroy_marked_entities(self)
    for entity in self.entities_marked_for_destroy:values() do
        entity:remove_all_components()
        if self.entity_to_entity_trackers_map:has(entity) then
            for tracker in self.entity_to_entity_trackers_map:get(entity):entries() do
                tracker:check_and_untrack_entity(entity.id)
            end
        end
        self.entity_to_entity_trackers_map:delete(entity)
        self.entities:deleteValue(entity)
        self.id_to_entity:delete(entity.id)
    end
    self.entities_marked_for_destroy:clear()
end
function EntityManager.prototype.get_entity(self, id)
    return self.id_to_entity:get(id)
end
function EntityManager.prototype.is_entity_tracker(self, engine)
    return engine.check_and_untrack_entity ~= nil
end
function EntityManager.prototype.get_or_create_entity_tracker_set(self, component_type)
    if not self.component_type_to_entity_trackers_map:has(component_type) then
        self.component_type_to_entity_trackers_map:set(component_type, GCOptimizedList.new())
    end
    return self.component_type_to_entity_trackers_map:get(component_type)
end
function EntityManager.prototype.check_and_register_entity(self, entity)
    for component_type in entity.component_types:entries() do
        if self.component_type_to_entity_trackers_map:has(component_type) then
            for entity_tracker in self.component_type_to_entity_trackers_map:get(component_type):values() do
                if entity_tracker:check_and_track_entity(entity.id) then
                    if not self.entity_to_entity_trackers_map:has(entity) then
                        self.entity_to_entity_trackers_map:set(entity, GCOptimizedSet.new())
                    end
                    self.entity_to_entity_trackers_map:get(entity):add(entity_tracker)
                end
            end
        end
    end
end
return ____exports
