--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["4"] = 1,["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 1,["16"] = 1,["17"] = 1,["18"] = 1,["19"] = 1,["20"] = 1,["21"] = 1,["22"] = 1,["23"] = 1,["24"] = 1,["25"] = 1,["26"] = 10,["27"] = 10,["28"] = 10,["29"] = 12,["30"] = 10,["31"] = 10,["32"] = 10,["33"] = 10,["34"] = 10,["35"] = 1,["36"] = 20,["37"] = 20,["38"] = 1,["39"] = 24,["40"] = 24,["41"] = 24,["42"] = 24,["43"] = 1,["44"] = 30,["45"] = 30,["46"] = 1,["47"] = 37,["48"] = 37,["49"] = 37,["50"] = 37,["51"] = 37,["52"] = 37,["53"] = 37,["54"] = 37,["55"] = 37,["56"] = 37,["57"] = 37,["58"] = 37,["59"] = 1,["60"] = 50,["61"] = 51,["62"] = 50,["63"] = 50,["64"] = 50,["65"] = 50,["66"] = 50,["67"] = 57,["68"] = 57,["69"] = 59,["70"] = 57,["71"] = 57,["72"] = 57,["73"] = 50,["74"] = 50,["75"] = 50,["76"] = 1,["77"] = 68,["78"] = 68,["79"] = 70,["80"] = 70,["81"] = 70,["82"] = 68,["83"] = 68,["84"] = 68,["85"] = 68,["86"] = 1,["87"] = 1});
local ____exports = {}
____exports.PriorityQueue = {}
local PriorityQueue = ____exports.PriorityQueue
PriorityQueue.name = "PriorityQueue"
PriorityQueue.__index = PriorityQueue
PriorityQueue.prototype = {}
PriorityQueue.prototype.____getters = {}
PriorityQueue.prototype.__index = __TS__Index(PriorityQueue.prototype)
PriorityQueue.prototype.constructor = PriorityQueue
function PriorityQueue.new(...)
    local self = setmetatable({}, PriorityQueue.prototype)
    self:____constructor(...)
    return self
end
function PriorityQueue.prototype.____constructor(self)
    self.items = Map.new()
    self.priority_map = Map.new()
    self._size = 0
end
function PriorityQueue.prototype.____getters.size(self)
    return self._size
end
function PriorityQueue.prototype.add(self, value, priority)
    for ____TS_value in __TS__Iterator(self.items) do
        local index, v = unpack(____TS_value)
        if priority < self.priority_map:get(v) then
            self:insert(index, value, priority)
            return
        end
    end
    self:insert(self._size, value, priority)
end
function PriorityQueue.prototype.find_min(self)
    return self.items:get(0)
end
function PriorityQueue.prototype.delete_min(self)
    local min = self.items:get(0)
    self:delete(0)
    return min
end
function PriorityQueue.prototype.empty(self)
    return self.size == 0
end
function PriorityQueue.prototype.to_array(self)
    local entry_array = {}
    for entry in __TS__Iterator(self.items:entries()) do
        __TS__ArrayPush(entry_array, entry)
    end
    local sorted_array = __TS__ArraySort(entry_array, function(____, a, b) return a[0 + 1] - b[0 + 1] end)
    local values = {}
    for ____TS_index = 1, #sorted_array do
        local entry = sorted_array[____TS_index]
        __TS__ArrayPush(values, entry[1 + 1])
    end
    return values
end
function PriorityQueue.prototype.delete(self, index)
    if self.items:has(index) then
        local value = self.items:get(index)
        self.items:delete(index)
        self.priority_map:delete(value)
        local k = index
        self._size = self._size - 1
        while k < self.size do
            local one_up_value = self.items:get(k + 1)
            if one_up_value ~= nil then
                self.items:set(k, one_up_value)
            end
            k = k + 1
        end
        self.items:delete(self.size)
    end
end
function PriorityQueue.prototype.insert(self, index, value, priority)
    local k = self._size
    while k > index do
        self.items:set(k, self.items:get(k - 1))
        k = k - 1
    end
    self.items:set(index, value)
    self.priority_map:set(value, priority)
    self._size = self._size + 1
end
return ____exports
