--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["4"] = 1,["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 1,["16"] = 1,["17"] = 1,["18"] = 1,["19"] = 1,["20"] = 1,["21"] = 1,["22"] = 1,["23"] = 1,["24"] = 1,["25"] = 1,["26"] = 1,["27"] = 1,["28"] = 1,["29"] = 1,["30"] = 10,["31"] = 10,["32"] = 10,["33"] = 10,["34"] = 1,["35"] = 18,["36"] = 12,["37"] = 15,["38"] = 16,["39"] = 18,["40"] = 18,["41"] = 1,["42"] = 23,["43"] = 23,["44"] = 1,["45"] = 27,["46"] = 27,["47"] = 27,["48"] = 30,["49"] = 27,["50"] = 32,["51"] = 33,["52"] = 27,["53"] = 27,["54"] = 37,["55"] = 27,["56"] = 27,["57"] = 27,["58"] = 27,["59"] = 27,["60"] = 27,["61"] = 1,["62"] = 1});
local ____exports = {}
local __TSTL_tstl_gc_optimized_collections = require("tstl-gc-optimized-collections")
local GCOptimizedMap = __TSTL_tstl_gc_optimized_collections.GCOptimizedMap
local GCOptimizedSet = __TSTL_tstl_gc_optimized_collections.GCOptimizedSet
local GCOptimizedSortedList = __TSTL_tstl_gc_optimized_collections.GCOptimizedSortedList
local __TSTL_draw_component = require("encompass-ecs.draw_component")
local DrawComponent = __TSTL_draw_component.DrawComponent
local __TSTL_draw_layer_manager = require("encompass-ecs.draw_layer_manager")
local DrawLayerManager = __TSTL_draw_layer_manager.DrawLayerManager
local __TSTL_entity = require("encompass-ecs.entity")
local Entity = __TSTL_entity.Entity
local __TSTL_drawable = require("encompass-ecs.interfaces.drawable")
local IDrawable = __TSTL_drawable.IDrawable
local __TSTL_entity = require("encompass-ecs.renderers.entity")
local EntityRenderer = __TSTL_entity.EntityRenderer
local __TSTL_type_guards = require("encompass-ecs.type_guards")
local TypeGuard = __TSTL_type_guards.TypeGuard
local __TSTL_generic_type = require("encompass-ecs.types.generic_type")
local Type = __TSTL_generic_type.Type
____exports.RenderManager = {}
local RenderManager = ____exports.RenderManager
RenderManager.name = "RenderManager"
RenderManager.__index = RenderManager
RenderManager.prototype = {}
RenderManager.prototype.__index = RenderManager.prototype
RenderManager.prototype.constructor = RenderManager
function RenderManager.new(...)
    local self = setmetatable({}, RenderManager.prototype)
    self:____constructor(...)
    return self
end
function RenderManager.prototype.____constructor(self, entity_to_id_map)
    self.draw_component_type_to_renderer = GCOptimizedMap.new()
    self.layer_index_to_drawable_set = GCOptimizedMap.new()
    self.order = GCOptimizedSortedList.new()
    self.entity_to_id_map = entity_to_id_map
    self.draw_layer_manager = DrawLayerManager.new(self.layer_index_to_drawable_set, self.order)
end
function RenderManager.prototype.register_entity_renderer(self, renderer)
    self.draw_component_type_to_renderer:set(renderer.draw_component_type, renderer)
end
function RenderManager.prototype.draw(self)
    for _, layer_index in self.order:entries() do
        for drawable in self.layer_index_to_drawable_set:get(layer_index):entries() do
            if TypeGuard:drawable_is_general_renderer(drawable) then
                drawable:render()
            elseif TypeGuard:drawable_is_draw_component(drawable) then
                if self.draw_component_type_to_renderer:has(drawable.type) then
                    local renderer = self.draw_component_type_to_renderer:get(drawable.type)
                    local entity = self.entity_to_id_map:get(drawable.entity_id)
                    if renderer:is_tracking(entity.id) then
                        renderer:render(entity)
                    end
                end
            end
        end
    end
end
return ____exports
