--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["4"] = 1,["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 1,["16"] = 1,["17"] = 1,["18"] = 1,["19"] = 1,["20"] = 1,["21"] = 1,["22"] = 1,["23"] = 1,["24"] = 1,["25"] = 1,["26"] = 1,["27"] = 1,["28"] = 1,["29"] = 1,["30"] = 1,["31"] = 21,["32"] = 21,["33"] = 21,["34"] = 21,["35"] = 1,["36"] = 21,["37"] = 21,["38"] = 21,["39"] = 21,["40"] = 1,["41"] = 40,["42"] = 40,["43"] = 40,["44"] = 43,["45"] = 40,["46"] = 40,["47"] = 40,["48"] = 1,["49"] = 47,["50"] = 47,["51"] = 47,["52"] = 50,["53"] = 47,["54"] = 47,["55"] = 47,["56"] = 1,["57"] = 56,["58"] = 56,["59"] = 1,["60"] = 60,["61"] = 60,["62"] = 1,["63"] = 1});
local ____exports = {}
local __TSTL_component = require("encompass-ecs.component")
local Component = __TSTL_component.Component
local __TSTL_draw_component = require("encompass-ecs.draw_component")
local DrawComponent = __TSTL_draw_component.DrawComponent
local __TSTL_entity_checker = require("encompass-ecs.engines.utility.entity_checker")
local EntityChecker = __TSTL_entity_checker.EntityChecker
local __TSTL_entity_tracker = require("encompass-ecs.engines.utility.entity_tracker")
local EntityTracker = __TSTL_entity_tracker.EntityTracker
local __TSTL_entity = require("encompass-ecs.entity")
local Entity = __TSTL_entity.Entity
local __TSTL_drawable_entity_tracker = require("encompass-ecs.interfaces.drawable_entity_tracker")
local IDrawableEntityTracker = __TSTL_drawable_entity_tracker.IDrawableEntityTracker
local __TSTL_renderer = require("encompass-ecs.renderer")
local Renderer = __TSTL_renderer.Renderer
local __TSTL_generic_type = require("encompass-ecs.types.generic_type")
local Type = __TSTL_generic_type.Type
____exports.EntityRenderer = {}
local EntityRenderer = ____exports.EntityRenderer
EntityRenderer.name = "EntityRenderer"
EntityRenderer.__index = EntityRenderer
EntityRenderer.prototype = {}
EntityRenderer.prototype.__index = EntityRenderer.prototype
EntityRenderer.prototype.constructor = EntityRenderer
EntityRenderer.____super = Renderer
setmetatable(EntityRenderer, EntityRenderer.____super)
setmetatable(EntityRenderer.prototype, EntityRenderer.____super.prototype)
function EntityRenderer.new(...)
    local self = setmetatable({}, EntityRenderer.prototype)
    self:____constructor(...)
    return self
end
function EntityRenderer.prototype.____constructor(self, ...)
    Renderer.prototype.____constructor(self, ...)
    self.component_types = {}
    self.entity_tracker = EntityTracker.new()
end
function EntityRenderer.prototype.check_and_track_entity(self, entity_id)
    local entity = self:get_entity(entity_id)
    local should_track = self:check_entity(entity)
    if should_track then
        self.entity_tracker:track_entity(entity_id)
    end
    return should_track
end
function EntityRenderer.prototype.check_and_untrack_entity(self, entity_id)
    local entity = self:get_entity(entity_id)
    local should_untrack = entity == nil or not self:check_entity(entity)
    if should_untrack then
        self.entity_tracker:untrack_entity(entity_id)
    end
    return should_untrack
end
function EntityRenderer.prototype.is_tracking(self, id)
    return self.entity_tracker.tracked_ids:has(id)
end
function EntityRenderer.prototype.check_entity(self, entity)
    return EntityChecker:check_entity(entity, self.component_types) and entity:has_component(self.draw_component_type)
end
return ____exports
