/** @luaIterator */
export interface GCOptimizedSetIterable<T> extends Iterable<T> {
}
export declare class GCOptimizedSet<TValue> {
    static readonly Empty: GCOptimizedSet<any>;
    readonly size: number;
    private items;
    constructor(...items: TValue[]);
    entries(): GCOptimizedSetIterable<TValue>;
    add(value: TValue): GCOptimizedSet<TValue>;
    clear(): void;
    delete(value: TValue): boolean;
    has(value: TValue): boolean;
}
