// this has a hack to get around TSTL clobbering class names
// once TSTL supports better class name logic, rewrite please

import { Component } from "../../component";
import { Type } from "../../types/generic_type";

declare const _VERSION: string | undefined;

export function Detects(...component_type_args: Type<Component>[]) {
    return <T extends new(...args: any[]) => {}>(constructor: T) => {
        const c = class extends constructor {
            public component_types: Type<Component>[] = [...component_type_args];
        };
        if (typeof _VERSION !== "undefined") {
            (c as any).name = constructor.name; // hack until TSTL has more clever class name logic
        }
        return c;
    };
}
