import { Component } from "../component";
import { Type } from "../types/generic_type";

export interface IEntityTracker {
    readonly component_types: Type<Component>[];

    check_and_track_entity(entity_id: number): boolean;
    check_and_untrack_entity(entity_id: number): boolean;
}
